#ifndef INDIVIDUAL_H
#include "individl.h"
#endif

#ifndef POPULATION_H
#include "populati.h"
#endif

#ifndef GA_H
#include "ga.h"
#endif

#ifndef GAINFO_H
#define GAINFO_H

class GAinfo {

private:
  int        sum;     // species_number needs this
  individual maxind;  // maximum needs this
  individual maximum(GA&,unsigned char*,signed char);

public:
  void   save(GA&,ostream&,int=2);
  individual maximum(GA& ga,unsigned char* s) { return maximum(ga,s,0); };
  individual maximum_all(GA& ga,unsigned char* s) { return maximum(ga,s,1); };
  int    count(GA& ga,unsigned char* s)
         { taxon_chart_t* tree=ga.pop.pointer(s); return tree==NULL ? -1 :
                                                        tree->count; };
  int    count_all(GA& ga,unsigned char* s)
         { taxon_chart_t* tree=ga.pop.pointer(s); return tree==NULL ? -1 :
                                                        tree->countall; };
  int    strict(GA& ga) { return ga.pop.min_rad_index; };
  signed char   species_exists(GA& ga,unsigned char* s)
         { return (count(ga,s)!=-1); };
  void       iterstart(GA& ga,unsigned char* s) { ga.pop.iterstart(s); };
  individual iteradd(GA& ga)                  { return *(ga.pop.iteradd()); };
  signed char iterend(GA& ga)                { return ga.pop.iterend(); };
  signed char iter_all_end(GA& ga)         { return ga.pop.iter_all_end(); };
  //
  // while iterating, members of class GA mustn't be used!
  //
  double dpop_(GA& ga) { return ga.dpop; };
  double spec_rad_(GA& ga,int i) { return ga.spec_rad[i<0?0:(i>8?8:i)]; };
  int    P_m_(GA& ga) { return ga.P_m; };
  int    dying_off_error_(GA& ga) { return ga.dying_off_error; };
  int    species_number(GA& ga) { return ga.pop.species_number; };
};

#endif